define({"0":{y:0,u:"../Content/Extensions/about.html",l:-1,t:"How to use this developer guide",i:0.0184428545092164,a:"This section provides  navigation tips and  information on typographical conventions, feedback options, and additional documentation. Navigation Use following controls to navigate the content in this manual: The arrow buttons   and   at the top of any page bring you to the next or previous heading. ..."},"1":{y:0,u:"../Content/Extensions/extension-overview.html",l:-1,t:"Extension overview",i:0.0184428545092164,a:"Helix Core server extensions are a means for administrators to customize workflow. These extensions allow you to extend product behavior in a close integration between  the Helix Core Server runtime and your custom logic. Server extensions are self-contained bundles of code, metadata, and other ..."},"2":{y:0,u:"../Content/Extensions/extensiondevelopment.html",l:-1,t:" Server extension creation",i:0.0184428545092164,a:" Server extension creation Workflow to create and deploy a server extension Create On the client, run p4 extension --sample extName to create a skeleton of a server extension under the extName directory. Edit the placeholder data in the  extName/manifest.json file. (See  Server Extension JSON ..."},"3":{y:0,u:"../Content/Extensions/extensionspec.html",l:-1,t:"Server extension configuration (global and instance specs)",i:0.0542304810782744,a:"After you have installed the server extension, configure the extension specs. One or more \"instance\" specs are required.  Each instance can provide different values for the extension’s instance variables. Pre-populated, read-only fields of the extension spec Some read-only fields are pre-populated ..."},"4":{y:0,u:"../Content/Extensions/extensionjson.html",l:-1,t:"Server Extension JSON manifest fields",i:0.0684594867697366,a:"The server extension manifest is a UTF-8 encoded JSON file containing supporting metadata that the Helix Core Server uses. Fields Example manifest.json { \"manifest_version\":1, \"api_version\":1, \"script_runtime\":{ \"language\":\"Lua\", \"version\":\"5.3\" }, \"key\":\"aaaaa-aaaa-aaaa-aaaa-aaaaa\", ..."},"5":{y:0,u:"../Content/Extensions/extensionbasics.html",l:-1,t:"Extension basics",i:0.0257344682066177,a:"Signed extension A signed extension assures a third party that the extension package and its code has not been altered. Signing your extension is optional.   For a walkthrough of the signing process, see  Creating and Installing Helix Core Signed Extensions  in the  Perforce Knowledgebase . ..."},"6":{y:0,u:"../Content/Extensions/extensioncallbacks.html",l:-1,t:"Server extension callbacks",i:0.176227563601728,a:"This section compares the function syntax of a server extension to the equivalent logic in a trigger. Example usage of a server extension compared to a trigger Event Callbacks The following table lists the Helix Core events that can cause a server extension  to run. Instead of managing a trigger ..."},"7":{y:0,u:"../Content/Extensions/extension-variables.html",l:-1,t:"Server extension session variables",i:0.0931405872613795,a:"This section assumes you have read the  Server extension callbacks  page. A server extension can get the data about the current command context from the server. The server extension is responsible for interpreting and\n      using these appropriately. The  maxError…​ variables refer to circumstances ..."},"8":{y:0,u:"../Content/Extensions/extensiontroubleshoot.html",l:-1,t:"Server extension errors and troubleshooting",i:0.0223620445708716,a:"Server extension errors and troubleshooting As seen from the client-side, here are some errors and where to look for answers:"},"9":{y:0,u:"../Content/Extensions/third-party-libraries.html",l:-1,t:"Third party libraries for Extensions",i:0.0184428545092164,a:"Third party libraries for Extensions The following libraries are bundled with the Helix Core server for use with Extensions: The  cURL data transfer library  via the  Lua-cURLv3  binding. The  SQLite3  SQL database via the  LuaSQLite3  binding. The  cjson  JSON encoder/decoder."},"10":{y:0,u:"../Content/Extensions/extensions.classes.html",l:-1,t:"Classes and methods",i:0.0223620445708716,a:"Classes and methods The  Class P4.P4 deals with general things, such as connecting to the server, and the  Class Helix.Core.Server class is specific to server extensions."},"11":{y:0,u:"../Content/Extensions/extensions.p4.html",l:-1,t:"Class P4.P4 ",i:0.0486045713896057,a:" An interface to the\n      Helix Server\n      client API.  See the information about examples at  https://swarm.workshop.perforce.com/files/guest/perforce_software/extensions/main/README.md and the examples at a specific release, such as  ..."},"12":{y:0,u:"../Content/Extensions/extensions.p4_map.html",l:-1,t:"Class P4.Map ",i:0.0184428545092164,a:" Description The  P4.Map class allows users to create and work\n      with\n      Helix Server\n      mappings without requiring a connection to a Helix Core Server. Class Methods Map.join ( map1, map2 ) -\u003e Map Join two  P4.Map objects and create a third. The new map is composed of the left-hand side ..."},"13":{y:0,u:"../Content/Extensions/extensions.p4_message.html",l:-1,t:"Class P4.Message",i:0.0184428545092164,a:"Description P4.Message objects contain error or other\n      diagnostic messages from the\n      Helix Core Server. Retrieve\n      them by using the messages() method.  Instance methods message.severity() -\u003e number Severity of the message. message.generic() -\u003e number Returns the generic class of the ..."},"14":{y:0,u:"../Content/Extensions/helix.server.html",l:-1,t:"Class Helix.Core.Server",i:0.263645308378662,a:"Class methods ClientEditData( string, function ) -\u003e bool, string Allow Lua writer using RunCommand to send an input form to the User for editing. Returns: bool - return 1 on success, otherwise 0 string - with edited content of the form if success, with unedited content of the form containing an ..."},"15":{y:0,u:"../Content/Extensions/MFA-class.html",l:-1,t:"Class Helix.Core.Server.MFA",i:0.0184428545092164,a:"This class exposes the Helix Core Server multifactor authentication properties. Class properties Status Values are: SUCCESS FAILURE NO_MFA Scheme Values are: OTP_GENERATED - A one-time-password generated by a user device OTP_REQUESTED - A one-time-password sent to the user CHALLENGE - A ..."},"16":{y:0,u:"../Content/Extensions/helix.core.server.i18n.html",l:-1,t:"Class Helix.Core.Server.i18n",i:0.0184428545092164,a:"Class methods  GetLocale() -\u003e string Get the current locale for the user translations. Returns a string. SetLocale(string) Set the locale for the current user translations. Only necessary if overriding the defaults. GetMessage(string, strings, ... ) -\u003e string Get a translated message. Parameters:  ..."},"17":{y:0,u:"../Content/Extensions/custom-commands.html",l:-1,t:"Using Extensions to make custom commands",i:0.0223620445708716,a:"A custom command made with an Extension allows the developer to create a new, single command that might:  combine the functionality of one or more standard p4  commands call one or more triggers add custom logic Such commands  resemble native Helix Core commands in that they can have tagged output, ..."},"18":{y:0,u:"../Content/Shared/glossary.html",l:-1,t:"Glossary",i:0.0184428545092164,a:"Glossary"},"19":{y:0,u:"../Content/Extensions/license.statements.html",l:-1,t:"License statements",i:0.0184428545092164,a:"License statements To get a listing of the third-party software licenses that Helix Core Server uses, at the command line, type the p4 help legal command. To get a listing of the third-party software licenses that the local client uses, at the command line, type the p4 help -l legal command."},"20":{y:0,u:"../Content/Extensions/sitemap.html",l:-1,t:"sitemap",i:0.0184428545092164,a:"Site Map"},});